shell.closeConsole();
//shell.launchConsole(0, 0, desktop.Width(), 64);
var caption = 'graphite :: Brushed Metal';

var programs_menu, favorites_menu, documents_menu, main_menu, Settings_menu;

var button_arrow_up, button_arrow_down;
var dragbar, dragbar_left, dragbar_right, dragbar_middle;
var systray_container, lsmail_container, alsclock_container, mp3_container, lslm_container;
var mp3_prev, mp3_play, mp3_next, mp3_open, mp3_stop, mp3_pause;

// global command identifiers
var shellExit = 1;
var shellRecycle = 2;
var systemLogoff = 3;
var systemShutdown = 4;
var changeTheme = 5;
var rebuildMenu = 6;
var dialupNetworking = 10;
var myComputer = 11;
var networkNeighbourhood = 12;
var recycleBin = 13;
var help = 14;
var runDlg = 15;
var explorer = 16;
var themeConfig = 17;

var controlPanel = 20;
var displayProperties = 21;
var printers = 22;
var scheduledTasks = 23;

var menuDocs = 50;
var menuFav = 51;
var menuPrograms = 52;
var menuSettings = 53;

// menu items

var mIcon = 1;
var mName = 2;
var mProg = 3;

var menuArray = new Array();
	menuArray[mIcon] = new Array();
		menuArray[mIcon][controlPanel] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\control panel.ico';
		menuArray[mIcon][dialupNetworking] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\dialup networking.ico';
		menuArray[mIcon][displayProperties] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\display properties.ico';
		menuArray[mIcon][help] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\help.ico';
		menuArray[mIcon][menuDocs] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\documents.ico';
		menuArray[mIcon][menuFav] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\favorites.ico';
		menuArray[mIcon][systemLogoff] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\logoff.ico';
		menuArray[mIcon][myComputer] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\my computer.ico';
		menuArray[mIcon][networkNeighbourhood] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\network neighbourhood.ico';
		menuArray[mIcon][printers] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\printers.ico';
		menuArray[mIcon][menuPrograms] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\programs.ico';
		menuArray[mIcon][recycleBin] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\recycle bin.ico';
		menuArray[mIcon][scheduledTasks] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\scheduled tasks.ico';
		menuArray[mIcon][menuSettings] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\Settings.ico';
		menuArray[mIcon][systemShutdown] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\shutdown.ico';
		menuArray[mIcon][runDlg] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\run.ico';
		menuArray[mIcon][changeTheme] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\my computer.ico';
		menuArray[mIcon][rebuildMenu] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\my computer.ico';
		menuArray[mIcon][shellRecycle] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\my computer.ico';
		menuArray[mIcon][shellExit] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\my computer.ico';
		menuArray[mIcon][themeConfig] = shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\my computer.ico';
	menuArray[mName] = new Array();
		menuArray[mName][controlPanel] = "Control Panel...";
		menuArray[mName][dialupNetworking] = "Dialup Networking...";
		menuArray[mName][displayProperties] = "Display Properties...";
		menuArray[mName][help] = 'Help...';
		menuArray[mName][menuDocs] = "Documents";
		menuArray[mName][menuFav] = "Favorites";
		menuArray[mName][systemLogoff] = "Log Off...";
		menuArray[mName][myComputer] = "My Computer...";
		menuArray[mName][networkNeighbourhood] = "Network Neighbourhood...";
		menuArray[mName][printers] = "Printers...";
		menuArray[mName][menuPrograms] = "Programs";
		menuArray[mName][recycleBin] = "Recycle Bin...";
		menuArray[mName][scheduledTasks] = "Scheduled Tasks...";
		menuArray[mName][menuSettings] = "Settings";
		menuArray[mName][systemShutdown] = "Shutdown...";
		menuArray[mName][runDlg] = "Run...";
		menuArray[mName][changeTheme] = "Change Theme...";
		menuArray[mName][rebuildMenu] = "Rebuild Start Menu...";
		menuArray[mName][shellRecycle] = "Recycle graphite...";
		menuArray[mName][shellExit] = "Exit graphite...";
		menuArray[mName][themeConfig] = "Configure Theme...";


// main command parser
function parseGlobalCommand(command)
{
	switch(command)
	{
		case themeConfig:
			ConfigureTheme();
			break;

		case changeTheme:
			shell.selectTheme();
			break;

		case systemShutdown:
			shell.shutdown();
			break;

		case runDlg:
			shell.run();
			break;

		case shellRecycle:
			shell.recycle();
			break;

		case shellExit:
			shell.quit();
			break;

		case dialupNetworking:
			shell.execute('explorer','/root,,::{7007ACC7-3202-11D1-AAD2-00805FC1270E}');
			break;

		case displayProperties:
			shell.execute('control','desk.cpl');
			break;

		case help:
			shell.execute(shell.GetShellPath()+'\\graphite.chm','');
			break;

		case myComputer:
			shell.execute('explorer','/root,,::{20D04FE0-3AEA-1069-A2D8-08002B30309D}');
			break;

		case networkNeighbourhood:
			shell.execute('explorer','/root,,::{208D2C60-3AEA-1069-A2D7-08002B30309D}');
			break;

		case recycleBin:
			shell.execute('explorer','/root,,::{645FF040-5081-101B-9F08-00AA002F954E}');
			break;

		case controlPanel:
			shell.execute('explorer','/root,,::{20D04FE0-3AEA-1069-A2D8-08002B30309D}\\::{21EC2020-3AEA-1069-A2DD-08002B30309D}');
			break;

		case printers:
			shell.execute('explorer','/root,,::{20D04FE0-3AEA-1069-A2D8-08002B30309D}\\::{2227A280-3AEA-1069-A2DE-08002B30309D}');
			break;

		case scheduledTasks:
			shell.execute('explorer','/root,,::{20D04FE0-3AEA-1069-A2D8-08002B30309D}\\::{D6277990-4C6A-11CF-8D87-00AA0060F5BF}');
			break;

		case rebuildMenu:
			DestroyStartMenu();
			break;

		case explorer:
			shell.execute('explorer','');
			break;
	}
}

// finds the winamp window and executes command
function winampCommand(command)
{
	var winamp = shell.FindWindow('Winamp v1.x', '<any>');
	if (winamp)
	{
		shell.SendMessage(winamp, 273, command, 0);
	} else {
		shell.MessageBox(caption, 'Unable to locate Winamp window');
	}
}


// build the start menu
function CreateStartMenu()
{
	var icon, path, folder_icon, default_icon;
	main_menu = menu.Create();
	Settings_menu = menu.Create();
	favorites_menu = menu.Create();
	documents_menu = menu.Create();
	programs_menu = menu.Create();
	if (programs_menu)
	{
		path = shell.GetSpecialFolderPath(0x0002);
		folder_icon = shell.loadIcon(shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\folder.ico');
		default_icon = shell.loadIcon(shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\default app.ico');
		menu.FillFromFolder(programs_menu, 1000, path, folder_icon, default_icon);
		if (folder_icon) shell.DestroyIcon(folder_icon);
		if (default_icon) shell.DestroyIcon(default_icon);
		if (path) delete(path);

		// all users for NT based systems
		if (shell.GetWindowsPlatform() == 1)
		{
			menu.addSeparator(programs_menu);

			path = shell.GetSpecialFolderPath(0x0017);
			folder_icon = shell.loadIcon(shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\folder.ico');
			default_icon = shell.loadIcon(shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\default app.ico');
			menu.FillFromFolder(programs_menu, 4000, path, folder_icon, default_icon);
			if (folder_icon) shell.DestroyIcon(folder_icon);
			if (default_icon) shell.DestroyIcon(default_icon);
			if (path) delete(path);
		}
	}
	if (favorites_menu)
	{
		path = shell.GetSpecialFolderPath(0x0006);
		folder_icon = shell.loadIcon(menuArray[mIcon][menuFav]);
		default_icon = shell.loadIcon(shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\default doc.ico');
		menu.FillFromFolder(favorites_menu, 2000, path, folder_icon, default_icon);
		if (folder_icon) shell.DestroyIcon(folder_icon);
		if (default_icon) shell.DestroyIcon(default_icon);
		if (path) delete(path);
	}
	if (documents_menu)
	{
		path = shell.GetSpecialFolderPath(0x0005);
		folder_icon = shell.loadIcon(menuArray[mIcon][menuDocs]);
		default_icon = shell.loadIcon(shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\default doc.ico');
		menu.FillFromFolder(documents_menu, 3000, path, folder_icon, default_icon);
		if (folder_icon) shell.DestroyIcon(folder_icon);
		if (default_icon) shell.DestroyIcon(default_icon);
		if (path) delete(path);
	}
	if (Settings_menu)
	{
		icon = shell.loadIcon(menuArray[mIcon][controlPanel]);
		menu.addString(Settings_menu, controlPanel, icon, menuArray[mName][controlPanel]);
		if (icon) shell.DestroyIcon(icon);

		menu.addSeparator(Settings_menu);

		icon = shell.loadIcon(menuArray[mIcon][displayProperties]);
		menu.addString(Settings_menu, displayProperties, icon, menuArray[mName][displayProperties]);
		if (icon) shell.DestroyIcon(icon);

		icon = shell.loadIcon(menuArray[mIcon][printers]);
		menu.addString(Settings_menu, printers, icon, menuArray[mName][printers]);
		if (icon) shell.DestroyIcon(icon);

		icon = shell.loadIcon(menuArray[mIcon][scheduledTasks]);
		menu.addString(Settings_menu, scheduledTasks, icon, menuArray[mName][scheduledTasks]);
		if (icon) shell.DestroyIcon(icon);

		menu.addSeparator(Settings_menu);

		icon = shell.loadIcon(menuArray[mIcon][changeTheme]);
		menu.addString(Settings_menu, changeTheme, icon, menuArray[mName][changeTheme]);
		if (icon) shell.DestroyIcon(icon);

		icon = shell.loadIcon(menuArray[mIcon][themeConfig]);
		menu.addString(Settings_menu, themeConfig, icon, menuArray[mName][themeConfig]);
		if (icon) shell.DestroyIcon(icon);

		icon = shell.loadIcon(menuArray[mIcon][shellExit]);
		menu.addString(Settings_menu, shellExit, icon, menuArray[mName][shellExit]);
		if (icon) shell.DestroyIcon(icon);

		icon = shell.loadIcon(menuArray[mIcon][rebuildMenu]);
		menu.addString(Settings_menu, rebuildMenu, icon, menuArray[mName][rebuildMenu]);
		if (icon) shell.DestroyIcon(icon);

		icon = shell.loadIcon(menuArray[mIcon][shellRecycle]);
		menu.addString(Settings_menu, shellRecycle, icon, menuArray[mName][shellRecycle]);
		if (icon) shell.DestroyIcon(icon);
	}
	if (main_menu)
	{
		icon = shell.loadIcon(menuArray[mIcon][menuPrograms]);
		menu.addPopup(main_menu, programs_menu, icon, menuArray[mName][menuPrograms]);
		if (icon) shell.DestroyIcon(icon);

		icon = shell.loadIcon(menuArray[mIcon][menuFav]);
		menu.addPopup(main_menu, favorites_menu, icon, menuArray[mName][menuFav]);
		if (icon) shell.DestroyIcon(icon);

		icon = shell.loadIcon(menuArray[mIcon][menuDocs]);
		menu.addPopup(main_menu, documents_menu, icon, menuArray[mName][menuDocs]);
		if (icon) shell.DestroyIcon(icon);

		icon = shell.loadIcon(menuArray[mIcon][menuSettings]);
		menu.addPopup(main_menu, Settings_menu, icon, menuArray[mName][menuSettings]);
		if (icon) shell.DestroyIcon(icon);

		icon = shell.loadIcon(menuArray[mIcon][help]);
		menu.addString(main_menu, help, icon, menuArray[mName][help]);
		if (icon) shell.DestroyIcon(icon);

		icon = shell.loadIcon(menuArray[mIcon][runDlg]);
		menu.addString(main_menu, runDlg, icon, menuArray[mName][runDlg]);
		if (icon) shell.DestroyIcon(icon);

		menu.addSeparator(main_menu);

		icon = shell.loadIcon(menuArray[mIcon][dialupNetworking]);
		menu.addString(main_menu, dialupNetworking, icon, menuArray[mName][dialupNetworking]);
		if (icon) shell.DestroyIcon(icon);

		icon = shell.loadIcon(menuArray[mIcon][myComputer]);
		menu.addString(main_menu, myComputer, icon, menuArray[mName][myComputer]);
		if (icon) shell.DestroyIcon(icon);

		icon = shell.loadIcon(menuArray[mIcon][networkNeighbourhood]);
		menu.addString(main_menu, networkNeighbourhood, icon, menuArray[mName][networkNeighbourhood]);
		if (icon) shell.DestroyIcon(icon);

		icon = shell.loadIcon(menuArray[mIcon][recycleBin]);
		menu.addString(main_menu, recycleBin, icon, menuArray[mName][recycleBin]);
		if (icon) shell.DestroyIcon(icon);

		menu.addSeparator(main_menu);

		icon = shell.loadIcon(menuArray[mIcon][systemLogoff]);
		menu.addString(main_menu, systemLogoff, icon, menuArray[mName][systemLogoff]);
		if (icon) shell.DestroyIcon(icon);

		icon = shell.loadIcon(menuArray[mIcon][systemShutdown]);
		menu.addString(main_menu, systemShutdown, icon, menuArray[mName][systemShutdown]);
		if (icon) shell.DestroyIcon(icon);
	}
}

// free's up the start menu
function DestroyStartMenu()
{
	if (favorites_menu) menu.Destroy(favorites_menu);
	if (documents_menu) menu.Destroy(documents_menu);
	if (programs_menu) menu.Destroy(programs_menu);
	if (Settings_menu) menu.Destroy(Settings_menu);
	if (main_menu) menu.Destroy(main_menu);
	main_menu = 0;
}

// display task switcher
function desktop::OnMButtonUp(x, y)
{
	var task_menu, icon, num, i;
	task_menu = menu.Create();
	if (task_menu)
	{
		num = tasks.GetCount();

		for (i = 1; i <= num; i++)
		{
			icon = tasks.GetIcon(i);
			menu.addString(task_menu, i, icon, tasks.GetCaption(i));
		}

		i = menu.showReturnCmd(task_menu, x, y);
		if (i > 0)
		{
			tasks.SwitchTo(i);
		}
		menu.Destroy(task_menu);
	}
}

// display main menu on right button click
function desktop::OnRButtonUp(x, y)
{
	// build start menu if its first time
	if (!main_menu) CreateStartMenu();
	menu.show(main_menu, x, y);
}

// menu command handler; pass messages on to global command handler
function menu::OnCommand(command)
{
	parseGlobalCommand(command);
}

// hotkey command handler; pass on to global
function hotkey::OnCommand(command)
{
	parseGlobalCommand(command);
}

// shell is going down; do any cleanups here
function shell::OnUnload()
{
	DestroyShortcuts();
	DestroyStartMenu();

	// play nice for other themes
	hotkey.Remove(explorer);
	hotkey.Remove(runDlg);
	hotkey.Remove(systemShutdown);
}

function shortcut::OnLButtonUp(sc, x, y)
{
	// swap in normal state images
	switch(sc)
	{
		case button_arrow_down:
			shortcut.SetBitmap(button_arrow_down, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\button_arrow_down_1.png', 0);
			break;

		case button_arrow_up:
			shortcut.SetBitmap(button_arrow_up, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\button_arrow_up_1.png', 0);
			break;

		case mp3_prev:
			shortcut.SetBitmap(mp3_prev, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\mp3_prev_1.png', 0);
			winampCommand(40044);
			break;

		case mp3_play:
			shortcut.SetBitmap(mp3_play, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\mp3_play_1.png', 0);
			winampCommand(40045);
			break;

		case mp3_next:
			shortcut.SetBitmap(mp3_next, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\mp3_next_1.png', 0);
			winampCommand(40048);
			break;

		case mp3_open:
			shortcut.SetBitmap(mp3_open, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\mp3_open_1.png', 0);
			winampCommand(40029);
			break;

		case mp3_stop:
			shortcut.SetBitmap(mp3_stop, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\mp3_stop_1.png', 0);
			winampCommand(40047);
			break;

		case mp3_pause:
			shortcut.SetBitmap(mp3_pause, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\mp3_pause_1.png', 0);
			winampCommand(40046);
			break;
	}
}

function shortcut::OnLButtonDown(sc, x, y)
{
	// swap in pressed state images
	switch(sc)
	{
		case button_arrow_down:
			shortcut.SetBitmap(button_arrow_down, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\button_arrow_down_2.png', 0);
			break;

		case button_arrow_up:
			shortcut.SetBitmap(button_arrow_up, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\button_arrow_up_2.png', 0);
			break;

		case mp3_prev:
			shortcut.SetBitmap(mp3_prev, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\mp3_prev_2.png', 0);
			break;

		case mp3_play:
			shortcut.SetBitmap(mp3_play, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\mp3_play_2.png', 0);
			break;

		case mp3_next:
			shortcut.SetBitmap(mp3_next, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\mp3_next_2.png', 0);
			break;

		case mp3_open:
			shortcut.SetBitmap(mp3_open, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\mp3_open_2.png', 0);
			break;

		case mp3_stop:
			shortcut.SetBitmap(mp3_stop, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\mp3_stop_2.png', 0);
			break;

		case mp3_pause:
			shortcut.SetBitmap(mp3_pause, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\mp3_pause_2.png', 0);
			break;
	}
}

function shortcut::OnDropFiles(sc, filename)
{
	shell.MessageBox(caption, filename);
}

function desktop::OnDropFiles(filename)
{
	var fso = new ActiveXObject("Scripting.FileSystemObject");
	var ext = fso.GetExtensionName(filename);

	if (ext == 'bmp')
	{
		// if dropped file is a bitmap, Set the desktop wallpaper
  		desktop.SetWallpaper(filename);
	}
	delete(fso);
}

// re-position shortcuts
function desktop::OnDisplayChange(width, height)
{
	PositionShortcuts();
}

// display about box
function DisplayAboutBox()
{
	about = 'Shell version: v'+shell.GetShellMajorVersion()+'.';
	if (shell.GetShellMinorVersion() < 10)
		about = about+'0';
	about = about + shell.GetShellMinorVersion() + ' Build ' + shell.GetShellBuildVersion();
	about = about + '\r\n';
	about = about + 'Windows version: v'+shell.GetWindowsMajorVersion()+'.';
	if (shell.GetWindowsMinorVersion() < 10)
		about = about+'0';
	about = about + shell.GetWindowsMinorVersion()+' Build ' + shell.GetWindowsBuildVersion();
	about = about + '\r\n';
	about = about + 'Shell Path: '+shell.GetShellPath();
	about = about + '\r\n';
	about = about + 'Theme: '+shell.GetThemeName();
	shell.MessageBox(caption, about);
}


// Create all the shortcuts
function CreateShortcuts()
{
	// floating desktop tiles
	systray_container = shortcut.Create(0, 0, 0, 64, 64);
	shortcut.alwaysOnTop(systray_container, true);
	shortcut.SetBitmap(systray_container, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\tile.png', 0);
	var wnd = shortcut.GetWindow(systray_container);
	systray.SetArea(4, 4, 60, 60);
	systray.SetOwner(wnd);
	systray.SetBkcolor(210,210,210);

	lsmail_container = shortcut.Create(0, 0, 0, 64, 64);
	shortcut.alwaysOnTop(lsmail_container, true);
	shortcut.SetBitmap(lsmail_container, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\tile.png', 0);
	shortcut.launchWharfMod(lsmail_container, shell.GetShellPath()+'\\mod\\lsmail.dll');

	alsclock_container = shortcut.Create(0, 0, 0, 64, 64);
	shortcut.alwaysOnTop(alsclock_container, true);
	shortcut.SetBitmap(alsclock_container, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\alsclock_bg.png', 0);
	shortcut.launchWharfMod(alsclock_container, shell.GetShellPath()+'\\mod\\alsclock.dll');

	mp3_container = shortcut.Create(0, 0, 0, 64, 64);
	shortcut.alwaysOnTop(mp3_container, true);
	shortcut.SetBitmap(mp3_container, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\tile.png', 0);

	lslm_container = shortcut.Create(0, 0, 0, 64, 64);
	shortcut.alwaysOnTop(lslm_container, true);
	shortcut.SetBitmap(lslm_container, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\tile.png', 0);
	shortcut.launchWharfMod(lslm_container, shell.GetShellPath()+'\\mod\\lslm.app');
	
  	// child mp3 buttons
	mp3_prev = shortcut.Create(mp3_container, 12, 20, 12, 12);
	shortcut.SetBitmap(mp3_prev, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\mp3_prev_1.png', 0);

	mp3_play = shortcut.Create(mp3_container, 24, 20, 12, 12);
	shortcut.SetBitmap(mp3_play, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\mp3_play_1.png', 0);

	mp3_next = shortcut.Create(mp3_container, 36, 20, 12, 12);
	shortcut.SetBitmap(mp3_next, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\mp3_next_1.png', 0);

	mp3_open = shortcut.Create(mp3_container, 12, 32, 12, 12);
	shortcut.SetBitmap(mp3_open, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\mp3_open_1.png', 0);

	mp3_stop = shortcut.Create(mp3_container, 24, 32, 12, 12);
	shortcut.SetBitmap(mp3_stop, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\mp3_stop_1.png', 0);

	mp3_pause = shortcut.Create(mp3_container, 36, 32, 12, 12);
	shortcut.SetBitmap(mp3_pause, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\mp3_pause_1.png', 0);

  // dragbar
	dragbar = shortcut.Create(0, 0, 0, 0, 16);
	shortcut.alwaysOntop(dragbar, true);

	button_arrow_down = shortcut.Create(dragbar, 0, 0, 16, 16);
	shortcut.SetBitmap(button_arrow_down, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\button_arrow_down_1.png', 0);

	button_arrow_up = shortcut.Create(dragbar, 0, 0, 16, 16);
	shortcut.SetBitmap(button_arrow_up, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\button_arrow_up_1.png', 0);

	dragbar_left = shortcut.Create(dragbar, 16, 0, 4, 16);
	shortcut.SetBitmap(dragbar_left, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\dragbar_left.png', 0);

	dragbar_middle = shortcut.Create(dragbar, 20, 0, 0, 16);
	shortcut.SetBitmap(dragbar_middle, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\dragbar_middle.png', 1);

	dragbar_right = shortcut.Create(dragbar, 0, 0, 4, 16);
	shortcut.SetBitmap(dragbar_right, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\dragbar_right.png', 0);
}

function DestroyShortcuts()
{
	if (button_arrow_down) shortcut.Destroy(button_arrow_down);
	if (button_arrow_up) shortcut.Destroy(button_arrow_up);
	if (dragbar) shortcut.Destroy(dragbar);
	if (dragbar_left) shortcut.Destroy(dragbar_left);
	if (dragbar_right) shortcut.Destroy(dragbar_right);
	if (dragbar_middle) shortcut.Destroy(dragbar_middle);
	if (systray_container) shortcut.Destroy(systray_container);
	if (lsmail_container) shortcut.Destroy(lsmail_container);
	if (alsclock_container) shortcut.Destroy(alsclock_container);
	if (lslm_container) shortcut.Destroy(lslm_container);
	if (mp3_container) shortcut.Destroy(mp3_container);
	if (mp3_prev) shortcut.Destroy(mp3_prev);
	if (mp3_play) shortcut.Destroy(mp3_play);
	if (mp3_next) shortcut.Destroy(mp3_next);
	if (mp3_open) shortcut.Destroy(mp3_open);
	if (mp3_stop) shortcut.Destroy(mp3_stop);
	if (mp3_pause) shortcut.Destroy(mp3_pause);
}

function PositionShortcuts()
{
	shortcut.SetWindowPos(systray_container, desktop.Width()-64, desktop.Height()-64);
	shortcut.SetWindowPos(lsmail_container, desktop.Width()-128, desktop.Height()-64);
	shortcut.SetWindowPos(alsclock_container, desktop.Width()-192, desktop.Height()-64);
	shortcut.SetWindowPos(mp3_container, desktop.Width()-256, desktop.Height()-64);
	shortcut.SetWindowPos(lslm_container, desktop.Width()-320, desktop.Height()-64);
	
	shortcut.SetWindowSize(dragbar, desktop.Width(), 16);
	shortcut.SetWindowPos(button_arrow_down, desktop.Width()-16, 0);
	shortcut.SetWindowSize(dragbar_middle, desktop.Width()-40, 16);
	shortcut.SetWindowPos(dragbar_right, desktop.Width()-20, 0);/**/
}

function ConfigureTheme()
{
	var icon;
	var vwm_page, iconbox_page, media_page, wnd;
	config.CreateDialog();
	icon = shell.loadIcon(shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\my computer.ico');
	iconbox_page = config.AddPage('Icon Box', icon);
	media_page = config.AddPage('Media Player', icon);
	vwm_page = config.AddPage('Virtual Desktop Manager', icon);
	if (icon) shell.DestroyIcon(icon);

	// iconbox
	wnd = config.CreateButton(iconbox_page, 0x03, 'Use the Icon Box', 10, 10, 200, 14);
	config.CheckButton(wnd, true);

	// mp3 player
	config.CreateButton(media_page, 0x09, 'Nullsoft Winamp', 10, 10, 200, 14);
	config.CreateButton(media_page, 0x09, 'Windows Media Player', 10, 30, 200, 14);

	// vdm
	wnd = config.CreateButton(vwm_page, 0x03, 'Use the Virtual Desktop Manager', 10, 10, 200, 14);
	config.CheckButton(wnd, true);

	config.CreateButton(vwm_page, 0x09, 'Style 1, 4 desktops', 30, 40, 200, 14);
	config.CreateImage(vwm_page, 0x0E, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\vwm.png', 30, 60, 279, 56);

	config.CreateButton(vwm_page, 0x09, 'Style 2, 4 desktops', 30, 140, 200, 14);
	config.CreateImage(vwm_page, 0x0E, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\vwm2.png', 30, 160, 147, 112);

	wnd = config.CreateButton(vwm_page, 0x09, 'Style 3, 2 desktops', 30, 295, 200, 14);
	config.CreateImage(vwm_page, 0x0E, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\vwm3.png', 30, 315, 147, 56);
	config.CheckButton(wnd, true);
}

desktop.SetWallPaper(shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\wallpaper.bmp');
desktop.AcceptFiles(true);
desktop.SetWorkArea(0, 16, desktop.Width(), desktop.height());

iconbox.Create(0, desktop.Height()-64, 10, 7, 15, 51, shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\iconbox.png', shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\iconbox_knob.png', 5, 91, 3);
iconbox.leftArrow(shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\iconbox_left_arrow.png', 0, 49);
iconbox.rightArrow(shell.GetShellPath()+'\\themes\\'+shell.GetThemeName()+'\\iconbox_right_arrow.png', 115, 49);

hotkey.Add('win', 'e', explorer);
hotkey.Add('win', 'r', runDlg);
hotkey.Add('win', 's', systemShutdown);

CreateShortcuts();
PositionShortcuts();

DisplayAboutBox();
